%%%% Consolidate force data into one matlab file
%%%% Requires file 'framesA[25 60 90 116].mat' to run
%%%%%%%%%% This file provides the impact and submerged frame, assuming that
%%%%%%%%%% the image numbers start at 1.

close all; clear all; clc;
F_V = 1/.56; %N/Volts, volts to newton calibration
plotRaw = 1;
Vcol = ['brmcg']; % linspace(2, 4, 100);
cmap = hsv(55);
cSplit = 12; %split cmap intervals

c = [cmap(5,:); cmap(2*cSplit,:); cmap(30,:); cmap(4*cSplit,:)];
gL = 0; %grey line; gL*[1 1 1];

%%%%% PREALLOCATIONS 0 %%%%%
force_V = zeros(7000,5);
button_V = zeros(7000,5);
button1 = zeros(7000,5);
% forceAd2 = zeros(7000,10);

col = 'brgcmykbrgcm'; %for cone angle
%thickness for velocity

kk = 1; %FOOR LOOP angle index initialized
for Ang = 25; %[25 60 90];
    %%%%%%% load 'frameA[].mat'; contains imp & sub frames %%%%%%%
    load(['framesA' num2str(Ang) '.mat'])
    
    
    if Ang == 25
        prefix = ['HAng12-5_H'];
        pickH = [20 30 40 60];
        ii = 1;  % FOR LOOP height index initialized
%     elseif Ang == 60
%         prefix = ['HAng' num2str(Ang/2) '_H'];
%         pickH = [20];
%         ii = 2;  % FOR LOOP height index initialized
%     elseif Ang == 90
%         prefix = ['HAng' num2str(Ang/2) '_H'];
%         pickH = [30];
%         ii = 2;  % FOR LOOP height index initialized
    end

%     ii = 1;  % FOR LOOP height index initialized
    %%%%%%%% Drop height changed here %%%%%%%
    for H = pickH; % drop height in cm
        if H == 20;
            timp = eval(['timpA' int2str(Ang) '(1,:)']);tsub = eval(['tsubA' int2str(Ang) '(1,:)']);
            fs=f0(1,:); ff=f1(1,:); V = V0(1); V1 = V; V2=V; %V1 = 2; V2 = 2.34;
        elseif H == 30;
            timp = eval(['timpA' int2str(Ang) '(2,:)']);  tsub = eval(['tsubA' int2str(Ang) '(2,:)']);
            fs=f0(2,:); ff=f1(2,:); V = V0(2); V1 = V; V2 = V;%V0 = 2.64; V1 = 2.72; V2 = 2.92;
        elseif H == 40;
            timp = eval(['timpA' int2str(Ang) '(3,:)']); tsub = eval(['tsubA' int2str(Ang) '(3,:)']);
            fs=f0(3,:); ff=f1(3,:); V = V0(3); V1=V; V2=V;%V1 = 3.06; V2 = 3.17;
        elseif H == 60;
            timp = eval(['timpA' int2str(Ang) '(4,:)']); tsub = eval(['tsubA' int2str(Ang) '(4,:)']);
            fs=f0(4,:); ff=f1(4,:); V = V0(4);  V1=V; V2=V;%V1 = 3.06; V2 = 3.17; V0 = eval(['V0_A' int2str(Ang) '_H60']);
        end
        
        %         timp = eval(['timpA' int2str(Ang) '(ii,:)'])
        
        jj = 1; %initialize trial counter.
        for tr = 1:5; %trial number
            name = [prefix num2str(H) '_00' num2str(tr) '.mat'];
            if exist(name)
                load(name)
                indexSensorLength = length(UntitledSensor.Data);
                indexButtonLength = length(UntitledButton.Data);
                force_V(1:indexSensorLength,tr) = UntitledSensor.Data; % voltage signal
                button_V(1:indexButtonLength,tr) = UntitledButton.Data;
                time_index = 1:length(force_V);
                clear pr
                pr = find(button_V(:,tr)<button_V(1,tr)/2,1); %%% when the button is pressed
                pr0 = pr+fs(tr); %%
                prf = pr+ff(tr);
                
                bump = find(force_V(:,tr)>9,1); % bumper
                force = -force_V(pr0:prf,tr);
                time = 1:length(force);
                
                %%%%% force and time are zeroed at the impact time %%%%%
                forceAd = (force - force(timp(tr)))*F_V; %force adjusted to start at zero
                timeAd = time-timp(tr); %time adjusted to start at impact
              
                L = 0.03/tan(Ang/2*pi/180); %%% length of cone, m
                qq = round(L/V*1000); %%% time to travel one cone length, in ms
                rr1 = timp(tr)-round(qq/3);
                rr2 = timp(tr)+3*qq;
                forceAd2(1:rr2-rr1+1,tr) = forceAd(rr1:rr2); %% fixing the range
                timeAd2(1:rr2-rr1+1,tr) = timeAd(rr1:rr2);
                
                
                
                
                HAng = Ang/2*pi/180; %%% half angle in radians
                npt = 1e2; %number of points
                R = 0.03; L = R/tan(HAng); %m
                rho = 1e3; Cd = 2/3;
                Fscale = 0.5*rho*pi*R^2*V^2*tan(HAng);
                Tscale = L/V*1000;
                Gscale = 0.5*rho*pi*R^2*V^2; %rho*9.81*L.*pi*R^2;
                
                if H==60
                figure(100)
%                 plot(timeAd,forceAd,'-')
                timeAd3(:,tr) = timeAd(timp(tr):timp(tr)+84);
                forceAd3(:,tr) = forceAd(timp(tr):timp(tr)+84);
                plot(timeAd3(:,tr)/Tscale,forceAd3(:,tr)/Fscale,'-'); hold on;
                plot(timeAd3(43,tr)/Tscale,forceAd3(43,tr)/Fscale,'o','markerfacecolor','r')
                
                end
                
                
                
                if plotRaw == 1
                    figure(eval(['10' num2str(kk) num2str(ii)])); %% raw force data, each window is a different Ang_Height combination
                    hold on;
                    %                 plot(time,force,[col(tr) '-']);
                    %                 plot(time(timp(tr)),force(timp(tr)),'o')
                    %                 plot(timeAd,forceAd,[col(tr) '-']);
                    plot(timeAd2(:,tr)/Tscale,forceAd2(:,tr)/Fscale,[col(tr) '-']);
                    %                 plot(timeAd(timp(tr)),forceAd(timp(tr)),['o'],'markerfacecolor','k');
                    %                 plot(timeAd(tsub(tr)),forceAd(tsub(tr)),[col(tr) 'o'],'markerfacecolor','k');
                    
                    title(['Full Angle: ' num2str(Ang) ' deg, Drop Height: ' int2str(H) 'cm, Impact Velocity: ~' num2str(V) 'm/s'])
                end
                
                jj = jj+1; %trial counter
            end
        end
        
        %%% take average of all trials for particular case %%%%
        avg_force = mean(forceAd2,2);
        avg_time = mean(timeAd2,2);
        std_force = std(forceAd2/Fscale,1,2);
        if H==60
            figure(100)
            plot(timeAd3/Tscale,mean(forceAd3,2)/Fscale,'-k','linewidth',3)
     
            var0 = var(forceAd3/Fscale,0,2); %variance at each time
            Eimp = sqrt(mean(var0(1:43))); % rms of variance from imp to submerged
            Esub = sqrt(mean(var0(43:end))); %rms of variance from submerged to 2H/V
            
            t1 = 1:43; t2 = 43:85;
            y_pred1 = mean(forceAd3(t1,:),2); y_pred2 = mean(forceAd3(t2,:),2);
            y1 = forceAd3(t1,:); y2 = forceAd3(t2,:);
            RMSE1 = sqrt(mean(mean((y1-y_pred1*ones(1,5)).^2)));
            RMSE2 = sqrt(mean(mean((y2-y_pred2*ones(1,5)).^2)));
        end
        
        clear forceAd2 timeAd2
        %%%%%%%%%% Theoretical Model %%%%%%%%%%%%%%%%%%
        %%%%%%% Model %%%%%%%%
        
        
        Area = pi*(R)^2; %m^2
        y1 = linspace(0, L, npt); y2 = linspace(L,3*L, npt); d = linspace(0,L, npt); %m
        y3 = linspace(L,3*L,length(avg_force)); %m
        R1 = tan(HAng)*y1; %m, changes in time
        
        
        if plotRaw == 1;
            figure(eval(['10' num2str(kk) num2str(ii)])); %% raw force data, each window is a different Ang_Height combination
            plot(avg_time/Tscale,avg_force/Fscale,'m-','Linewidth',4.5); hold on; %avg force
            
            aF = 2*rho*R1.^2.*tan(HAng).*(V)^2; % hydrodynamic impact force
            F_hp0 = 0*2*pi*rho*9.81*sin(HAng)*tan(HAng)*sqrt(1+tan(HAng)^2)*(1/6*y1.^3); % hydrostatic pressure force
            F_hp = 2*pi*sin(HAng)*tan(HAng)*sqrt(1+tan(HAng)^2)*rho*9.81*(.5*(L+d)*L^2-(1/3)*L^3); % hydrostatic pressure force
            F_steady = 0.5*rho*Cd*Area*V^2*tanh(HAng); % steady drag force
            
            F = [aF+1*F_hp0 F_steady*ones(1,npt)+F_hp];
            plot([y1/V y2/V]*1000/Tscale, F/Fscale, ['k-'],'LineWidth',ii*0.75) %theoretical force
            xlim([0 2]); box on;
            
            if H==60
                figure(100); 
            plot(timeAd3(1:43)/Tscale,mean(forceAd3(1:43,:),2)/Fscale+RMSE1/2,'-k','Linewidth',2.5);hold on;
            plot(timeAd3(1:43)/Tscale,mean(forceAd3(1:43,:),2)/Fscale-RMSE1/2,'-k','Linewidth',2.5);
            plot(timeAd3(43:85)/Tscale,mean(forceAd3(43:end,:),2)/Fscale+RMSE2/2,'-k','Linewidth',2.5);
            plot(timeAd3(43:85)/Tscale,mean(forceAd3(43:end,:),2)/Fscale-RMSE2/2,'-k','Linewidth',2.5);

                
                figure(1015)
            plot(1,1,'ok','Linewidth',4.5); hold on;
            plot(1,1+RMSE1/2,'ok','Linewidth',4.5);
            plot(1,1-RMSE1/2,'ok','Linewidth',4.5);
            plot(2,1+RMSE2/2,'ok','Linewidth',4.5);
            plot(2,1-RMSE2/2,'ok','Linewidth',4.5);
            xlim([0 2]); ylim([-0.5 2.5]);
            end
            %             figure(eval(['20' num2str(kk) num2str(ii)]));
%             errorbar(avg_force/Fscale,std_force,'rx')
            % %         xlim([-10 100]);% ylim([-.5 8])
            %         xlabel('Time, ms'); ylabel('Force, N')
            %         title(['Full Angle: ' num2str(Ang) ' deg, Drop Height: ' int2str(H) 'cm, Impact Velocity: ~' num2str(V0) 'm/s'])
        end
        
%                 figure(200); %Dimensional Plots
%                 plot(avg_time,avg_force,[col(kk) '-'],'LineWidth',ii*0.75); hold on;
% %                 plot([y1/V0 y2/V1]*1000, F, ['k-'],'LineWidth',ii*0.75)
%                 title('Color=angle, thickness=velocity')
%                 xlim([-10 100]); xlabel('Time, ms')
%                 ylim([-5 10]); ylabel('Force, N')
        %
        %         figure(300); %Nondimensionalized Plot
        %         plot(avg_time/Tscale,avg_force/Fscale,[col(kk) '-'],'LineWidth',ii*0.75); hold on;
        %         plot([y1/V y2/V]*1000./Tscale, F./Fscale, ['k-'],'LineWidth',ii*0.75)
        %         title('Color=angle, thickness=velocity')
        %         xlim([-0.1 3]); xlabel('Nondimensional Time')
        %         ylabel('Nondimensional Force')
        
        figure(2); %Nondimensionalized Plot
        plot(avg_time/Tscale,avg_force/Fscale, '-','LineWidth',4,'color',[c(ii,:)]); hold on;
        % plot(avg_time/Tscale,avg_force/Fscale, '-','LineWidth',kk*1,'color',[c(ii,:)]); hold on;
        %         plot([y1/V y2/V]*1000./Tscale, F./Fscale, ['k-'],'LineWidth',kk*0.75)
        title('Cone, Color=velocity, thickness=angle')
        xlabel('Nondimensional Time')
        ylabel('Nondimensional Force')
        
        figure(3); %Nondimensionalized Plot
        plot(avg_time/Tscale,avg_force./Gscale, '-','LineWidth',kk*1,'color',[c(ii,:)]); hold on;
        %         plot([y1/V y2/V]*1000./Tscale, F./Fscale, ['k-'],'LineWidth',kk*0.75)
        title('Color=velocity, thickness=angle')
        xlabel('Nondimensional Time')
        ylabel('Nondimensional Force')
        
        ii = ii+1; % height counter
    end
    
    
    kk = kk+1; % angle counter
end
% return
run('theory_1f.m')

figure(2)
set(gca, 'fontsize', 25, 'xlim', [0 2], 'ylim', [-0.1 3] ); box on;
xlabel('T/(R/V tan \beta)', 'fontsize', 20, 'FontName', 'Times New Roman')
ylabel('Non-dimensional Force', 'fontsize', 20, 'FontName', 'Times New Roman');

% figure(3)
% set(gca, 'fontsize', 25, 'xlim', [0 2], 'ylim', [-0.1 3] ); box on;
% xlabel('T/(R/V tan \beta)', 'fontsize', 20, 'FontName', 'Times New Roman')
% ylabel('Non-dimensional Force', 'fontsize', 20, 'FontName', 'Times New Roman');

% print(1,'-depsc', 'coneForce_D.eps');

% cd ../../
% print(2,'-depsc', 'coneForce_ND.eps');
% cd Codes/Cone_Force2


