%%%% Consolidate force data into one matlab file
%%%% Requires file 'framesA[25 60 90 116].mat' to run
%%%%%%%%%% This file provides the impact and submerged frame, assuming that
%%%%%%%%%% the image numbers start at 1.

F_V = 1/.56; %N/Volts, volts to newton calibration
plotRaw = 0;
% Vcol = ['brmcg']; % linspace(2, 4, 100);
% cmap = hsv(55);
% cSplit = 10; %split cmap intervals

c = [cmap(5,:); cmap(2*cSplit,:); cmap(30,:); cmap(4*cSplit,:)];
gL = 0; %grey line; gL*[1 1 1];


%thickness for velocity
 
kk = 1; %FOOR LOOP angle index initialized
for Ang = 25; %[25 60 90];
    %%%%%%% load 'frameA[].mat'; contains imp & sub frames %%%%%%%
    load(['framesA' num2str(Ang) '.mat'])

    if Ang == 25
        prefix = ['HAng12-5_H'];
        pickH = [20 30 40 60];
        ii = 1;  % FOR LOOP height index initialized
%     elseif Ang == 60
%         prefix = ['HAng' num2str(Ang/2) '_H'];
%         pickH = [20];
%         ii = 2;  % FOR LOOP height index initialized
%     elseif Ang == 90
%         prefix = ['HAng' num2str(Ang/2) '_H'];
%         pickH = [30];
%         ii = 2;  % FOR LOOP height index initialized
    end
    
%     ii = 1;  % FOR LOOP height index initialized
    %%%%%%%% Drop height changed here %%%%%%%
    for H = pickH; % drop height in cm
        if H == 20; 
            V = V0(1); V1 = V; V2=V; %V1 = 2; V2 = 2.34;
        elseif H == 30;
            V = V0(2); V1 = V; V2 = V;%V0 = 2.64; V1 = 2.72; V2 = 2.92;
        elseif H == 40;
            V = V0(3); V1=V; V2=V;%V1 = 3.06; V2 = 3.17;
        elseif H == 60;
            V = V0(4);  V1=V; V2=V;%V1 = 3.06; V2 = 3.17; V0 = eval(['V0_A' int2str(Ang) '_H60']);
        end
        
        %%%%%%%%%% Theoretical Model %%%%%%%%%%%%%%%%%%
        %%%%%%% Model %%%%%%%%
        HAng = Ang/2*pi/180; %%% half angle in radians
        npt = 1e2; %number of points
        R = 0.03; L = R/tan(HAng); %m
        rho = 1e3; Cd = 2/3;
        
        Area = pi*(R)^2; %m^2
        y1 = linspace(0, L, npt); y2 = linspace(L,3*L, npt); d = linspace(0,L, npt);
        
        R1 = tan(HAng)*y1; %m, changes in time
        
        Fscale = 0.5*rho*pi*R^2*V^2*tan(HAng); 
        Tscale = L/V*1000;
        Gscale = 0.5*rho*pi*R^2*V^2;%rho*9.81*y3.*pi*R^2;
        %%%%%%% Equations %%%%%%%%%%%
        F_buoy = pi/3*rho*9.81*R^2*L;
        aF = 2*rho*R1.^2.*tan(HAng).*(V)^2; % hydrodynamic impact force
        F_hp0 = 0*2*pi*rho*9.81*sin(HAng)*tan(HAng)*sqrt(1+tan(HAng)^2)*(1/6*y1.^3); % hydrostatic pressure force
        F_hp = 2*pi*sin(HAng)*tan(HAng)*sqrt(1+tan(HAng)^2)*rho*9.81*(.5*(L+d)*L^2-(1/3)*L^3); % hydrostatic pressure force
        F_steady = 0.5*rho*Cd*Area*V^2*tanh(HAng); % steady drag force
        
        F = [aF+1*F_hp0 F_steady*ones(1,npt)+F_hp+0*F_buoy];
        
        
        
%         figure(200); %Dimensional Plots
%         plot([y1/V0 y2/V1]*1000, F, ['k-'],'LineWidth',i*0.75)
%         title('Color=angle, thickness=velocity')
%         xlim([-10 100]); xlabel('Time, ms')
%         ylim([-5 10]); ylabel('Force, N')
%         
%         figure(300); %Nondimensionalized Plot
%         plot(avg_time/Tscale,avg_force/Fscale,[col(kk) '-'],'LineWidth',ii*0.75); hold on;
%         plot([y1/V y2/V]*1000./Tscale, F./Fscale, ['k-'],'LineWidth',ii*0.75)
%         title('Color=angle, thickness=velocity')
%         xlim([-0.1 3]); xlabel('Nondimensional Time')
%         ylabel('Nondimensional Force')


        T = [y1/V y2/V]*1000;
%         figure(2); %Nondimensionalized Plot
%         plot(avg_time/Tscale,avg_force/Fscale, '-','LineWidth',kk*0.75,'color',[col(ii)]); hold on;
% %         plot(T/Tscale, F./Fscale, ['k-'],'LineWidth',kk*0.75)
%         title('Color=velocity, thickness=angle')
%         xlim([-0.1 3]); xlabel('Nondimensional Time')
%         ylabel('Nondimensional Force')
%         
        figure(2); hold on;%%% plot impact and hydrostatic force
        plot((T)/Tscale,F/Fscale,'-', 'linewidth', 5,'color',gL*[1 1 1]); hold on;
        
        figure(3); hold on; 
        plot((T)/Tscale,F/Gscale,'-', 'linewidth', 5,'color',gL*[1 1 1]); hold on;

%         if H==30 && Ang==90
%             figure(2); hold on;%%% plot impact and hydrostatic force
%             TT = T/Tscale;
%             FF = F/Fscale;
%             iisave = 1;
%         else %%% plot only hydrostatic force
            figure(2)
            TT = T/Tscale;
            FF = F/Fscale;
            %%% solid theoretical line - hydrostatic
            plot(T(101:end)/Tscale,F(101:end)/Fscale,'-', 'linewidth', 5,'color',gL*[1 1 1]); hold on;
            
            %%% dotted theoretical line - hydrostatic
            plot(T(101:end)/Tscale,F(101:end)/Fscale,'-', 'linewidth', 1.5,'color',[c(ii,:)])
            
%         end
        
        ii = ii+1; % height counter
        
        
    end
    
   
    % return;
    
    kk = kk+1; % angle counter
end
figure(2)
%%% solid theoretical line - impact force
plot(TT(1:200),FF(1:200),['k-'], 'linewidth', 4);hold on;

%%% solid theoretical line - hydrostatic
plot(TT(101:200),FF(101:200),'-', 'linewidth', 3,'color',[c((4),:)]); 
%plot(TT(101:200),FF(101:200),'-', 'linewidth', 3,'color',gL*[1 1 1]); 

%%% dotted theoretical line - hydrostatic
% plot(TT(201:400),FF(201:400),':', 'linewidth', 3,'color',[cmap((ii-1)*cSplit,:)]); 
plot(TT(102:200),FF(102:200),'-', 'linewidth', 1.5,'color',[c((4),:)]); 
%%% solid theoretical line - impact force

% plot(TT(1:101),FF(1:101),['k-'], 'linewidth', 5);hold on;

